<template lang="pug">
.row.x-shifts.d-flex.justify-content-center
  .col-12.col-xl-9(key='results')
    ShiftPointsDialog(ref='shiftPointsDialog' :year='year')
    BaseCard
      template(v-slot:header='')
        BaseAnimationBlock
          .d-flex(key='title')
            h5 Shifts
            .ml-auto.d-flex.justify-content-between
              button.btn.btn-outline-info(@click='showDuePointsModal()')
                  i.fa.fa-chart-bar.mr-2
                  span Shift Points
              router-link(:to='"/shifts/stats"').mx-4
                button.btn.btn-outline-info
                  i.fa.fa-chart-bar.mr-2
                  span Statistics
              router-link(v-if='inEdit && !isAdmin && $store.getters.canAdmin' :to='"/admin" + $route.fullPath' title='Admin Mode')
                .clickable.border.border-danger.rounded.mx-2
                  i.fa.fa-key.text-danger.px-1
              .clickable(v-if='canBookShift && !inEdit' @click='setEdit(true)')
                kbd.keyHint.mr-2(v-if="showKeyHints") E
                i.fa.fa-cog
              .clickable(v-if='canBookShift && inEdit' @click='setEdit(false)' )
                kbd.keyHint.mr-2(v-if="showKeyHints") Esc
                i.fa.fa-times
      li(key='calendar').p-0
        .col-12.x-shifts-cal.p-0(:class="{ 'x-darkMode': darkMode }")
            BaseModalLoader(:isLoading="loading")
            calendar-view.theme-default(
                    :items="shiftsCal"
                    :itemContentHeight="'1.8em'"
                    :show-date='showDate'
                    :time-format-options="{ hour: 'numeric', minute: '2-digit' }"
                    :starting-day-of-week="1"
                    :displayWeekNumbers="true")
              calendar-view-header(slot='header' slot-scope='t' :header-props='t.headerProps' @input="setShowDate")
              template(v-slot:item='i')
                .cv-item(
                  :key="`${i.value.originalItem.id}`"
                  :title="i.value.originalItem.title"
                  :style="`top:${i.top};${i.value.originalItem.style}`"
                  :class="i.value.classes")
                  .mr-1.d-flex.justify-content-between
                    p.user-ellipsis
                      span.badge.bg-light.text-slot {{ i.value.originalItem.shiftKind }}
                      template(v-if="i.value.originalItem.assoId")
                        span.mx-1.text-user {{ i.value.originalItem.user | showUserInfo }}
                        span.text-muted.text-institute {{ i.value.originalItem.institute | showInstInfo }}
                    BaseAnimationBlock
                      .x-shift-actions(v-if="inEdit")
                        // Admin Actions
                        .d-flex.justify-content-between.text-danger(v-if="isAdmin")
                          .clickable.ml-1(v-if="i.value.originalItem.assoId" title="Free this slot")
                            i.fa.fa-times.align-middle(@click="doAssign(i.value.originalItem.id, null)")
                          .clickable.ml-1(title="Reserve this slot")
                            i.fas.fa-user-lock.align-middle(@click="doAssign(i.value.originalItem.id, 'Reserved')")
                          .clickable.ml-1(title="Cancel this slot")
                            i.fas.fa-ban.align-middle(@click="doAssign(i.value.originalItem.id, 'Cancelled')")
                        // User Actions
                        .d-flex.justify-content-between.text-secondary(v-else)
                          .clickable.ml-1(v-if="i.value.originalItem.assoId === null"
                            title="Take this slot")
                            i.fas.fa-user-plus.align-middle(@click="doAssign(i.value.originalItem.id, username)")
                          .clickable.ml-1(v-if="i.value.originalItem.user && isCurrentUser(i.value.originalItem.user.id || null)"
                            title="Free this slot")
                            i.fa.fa-times.align-middle(@click="doAssign(i.value.originalItem.id, null)")

            // Dialogs
            BaseDialog(ref='confirmDialog' title='Confirm Action')
              template(v-if="dialogInfo")
                h5.mb-4 Action: #[strong {{ dialogInfo.action }}]
                template(v-if="dialogInfo.shift")
                  h6 Shift Information
                  dl.row
                    dt.col-sm-2 Date
                    dd.col-sm-10 {{ `${new Date(dialogInfo.shift.date).toDateString()}`}}
                    dt.col-sm-2 Slot
                    dd.col-sm-10 {{ dialogInfo.shift.shiftKind }}
                    template(v-if="dialogInfo.username")
                      dt.col-sm-2 User
                      dd.col-sm-10 {{ dialogInfo.username }}
                p.mb-0 Do you confirm this action ?
</template>
<script>

export { default } from './Shifts.vue.js';

</script>

<style lang="scss">
.x-shifts-cal {
  max-height: 80vh;

    /* For long calendars, ensure each week gets sufficient height. The body of the calendar will scroll if needed */
  .cv-wrapper.period-month .cv-week {
    min-height: 10rem;
  }

  .cv-item .text-slot {
    font-size: 0.9rem;
    font-family: monospace;
    border: #4682B4 1px solid;
  }

  .cv-item .text-user {
    font-size: 0.8rem;
  }

  .cv-item p.user-ellipsis {
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
    max-width: 12vw;
    margin: 0;
    padding: 0;
  }

  .cv-item .text-institute {
    font-size: 0.7rem;
    font-family: monospace;
  }

  .cv-shift-leader {
    background-color: #3D59AB !important;
  }

  .cv-shift-leader .text-user,
  .cv-shift-leader .text-institute {
    color: white !important;
  }

  .cv-user-reserved {
    background-color: #FF9912 !important;
  }

  .cv-wrapper.period-month .cv-week .cv-weekdays .outsideOfMonth {
    background-color: #EAEAEA;
  }
}

// Light Mode / Default
.x-shifts-cal {
    background-color: white;

  .cv-day {
    background-color: white;
  }

  .today {
    background-color: #E5C687 !important;
  }
}

// Dark Mode
.x-shifts-cal.x-darkMode {
  background-color: black;

  .cv-wrapper {
    border: #888 1px solid;
  }

  .cv-header {
    background-color: black;
    border: #888 1px solid;

    .previousYear,
    .previousPeriod,
    .currentPeriod,
    .nextPeriod,
    .nextYear {
      background-color: black !important;
      color: white !important;
    }

  }

  .cv-weeknumber, .cv-header-day {
    background-color: black;
    color: white;
  }

  .cv-day {
    background-color: black;

    .today {
      background-color: #ffe;
    }
  }

  .text-user {
    color: black;
  }

  .cv-wrapper.period-month .cv-week .cv-weekdays .outsideOfMonth {
    background-color: #3A3A3A;
  }

  .today {
    background-color: #93c !important;
  }

}
</style>
